#include <stdio.h>

void ispis_niza(int niz[], int n) {
  int i;
  printf("Niz: ");
  for (i = 0; i < n; ++i)
    printf("%s%d", (i ? ", " : ""), niz[i]);
  printf("\n");
}

int mijau(int x) {
  int zadnja;
  if (x < 0) x = -x;
  zadnja = x % 17;
  while (x >= 17) x /= 17;
  return zadnja + x;
}

int grupaA(void) {
  int x[1719], n = 0, i, max, predzadnji_mijau;
  for (n = 0; n < 1719; ++n) {
    printf("Unesite x[%d]: ", n);
    scanf("%d", &x[n]);
    if (mijau(x[n]) > 13) break;
  }
  ispis_niza(x, n);
  max = x[n-2];
  predzadnji_mijau = mijau(max);
  for (i = 0; i < n; ++i)
    if (x[i] > max && mijau(x[i]) == predzadnji_mijau)
      max = x[i];
  printf("Rezultat: %d\n", max);
}

int ciju(int x) {
  int sum = 0;
  if (x < 0) x = -x;
  while (x) {
    sum += x % 9;
    x /= 9;
  }
  return sum;
}

int grupaB(void) {
  int x[1719], n = 0, i, min, predpredzadnji_ciju;
  for (n = 0; n < 1719; ++n) {
    printf("Unesite x[%d]: ", n);
    scanf("%d", &x[n]);
    if (ciju(x[n]) % 2 == 0) break;
  }
  ispis_niza(x, n);
  min = x[n-3];
  predpredzadnji_ciju = ciju(min);
  for (i = 0; i < n; ++i)
    if (x[i] < min && ciju(x[i]) == predpredzadnji_ciju)
      min = x[i];
  printf("Rezultat: %d\n", min);
}

int vuf(int x) {
  if (x < 0) x = -x;
  while (x >= 12) x /= 12;
  return x;
}

int grupaC(void) {
  int x[1719], n = 0, i, max, predzadnji_vuf;
  for (n = 0; n < 1719; ++n) {
    printf("Unesite x[%d]: ", n);
    scanf("%d", &x[n]);
    if (vuf(x[n]) < 5) break;
  }
  ispis_niza(x, n);
  max = x[n-2];
  predzadnji_vuf = vuf(max);
  for (i = 0; i < n; ++i)
    if (x[i] > max && vuf(x[i]) == predzadnji_vuf)
      max = x[i];
  printf("Rezultat: %d\n", max);
}

int iaaa(int x) {
  int cnt = 0, i;
  if (x < 0) x = -x;
  for (i = 2; i < x; ++i)
    if (x % i == 0) ++cnt;
  return cnt;
}

int grupaD(void) {
  int x[1719], n = 0, i, min, predpredzadnji_iaaa;
  for (n = 0; n < 1719; ++n) {
    printf("Unesite x[%d]: ", n);
    scanf("%d", &x[n]);
    if (iaaa(x[n]) % 2 == 1) break;
  }
  ispis_niza(x, n);
  min = x[n-3];
  predpredzadnji_iaaa = iaaa(min);
  for (i = 0; i < n; ++i)
    if (x[i] < min && iaaa(x[i]) == predpredzadnji_iaaa)
      min = x[i];
  printf("Rezultat: %d\n", min);
}

int main(void) {
  char c;
  while (1) {
    printf("Koju grupu zelite isprobati [a-d]? ");
    scanf(" %c", &c);
    switch (c) {
      case 'a': case 'A': grupaA(); break;
      case 'b': case 'B': grupaB(); break;
      case 'c': case 'C': grupaC(); break;
      case 'd': case 'D': grupaD(); break;
      default: continue;
    }
    break;
  }
  return 0;
}

